#include <iostream>
#include <vector>

// Changes sign of integer
void opposite(int& i) {
  i *= -1;
}

// Triangle structure with 6 coordinates
struct triangle {
  double x0,y0,x1,y1,x2,y2;
};

// Fonction that rotates content of a vector of pointers on doubles
void shift(std::vector<double*>& data) {
  double* tmp = data[0]; // Store pointer in temp variable
  for (unsigned int i=0; i<data.size()-1;i++)
    data[i] = data[i+1];
  data[data.size()-1] = tmp;
}

int main (int argc, char* argv[]) {

  int  i = 10;
  std::cout << "Initial value of i : " << i << std::endl;
  int *p = &i;
  (*p)++;
  std::cout << "Modified value using pointer : " << i << std::endl;
  
  opposite(i);
  std::cout << "Switched sign of i : " << i << std::endl;

  // Allocate vector of 10 triangles
  triangle* tris = new triangle[10];

  // We will try the shift function on a triangle's coordinates
  tris[0].x0 = 0.;
  tris[0].y0 = 1.;
  tris[0].x1 = 2.;
  tris[0].y1 = 3.;
  tris[0].x2 = 4.;
  tris[0].y2 = 5.;

  std::vector<double*> v(6);
  v[0] = &(tris[0].x0);
  v[1] = &(tris[0].y0);
  v[2] = &(tris[0].x1);
  v[3] = &(tris[0].y1);
  v[4] = &(tris[0].x2);
  v[5] = &(tris[0].y2);

  std::cout << "Initial coordinates" << std::endl;
  for(int i=0;i<v.size();i++)
    std::cout << *(v[i]) << " ";
  std::cout << std::endl;

  shift(v);
  std::cout << "Shifted coordinates" << std::endl;
  for(int i=0;i<v.size();i++)
    std::cout << *(v[i]) << " ";
  std::cout << std::endl;

  // Free 
  delete [] tris;

  return 0;

}
