#include "point.hpp" 
#include <cmath>

Point::Point() {
  _x = _y = 0.;
}

Point::Point(const double x, const double y) {
  _x = x;
  _y = y;
}

Point::Point(const Point& p2) {
  _x = p2._x;
  _y = p2._y;
}

void Point::display() {
  std::cout << "(" << _x << "," << _y << ")" << std::endl;
}

void Point::shift(double tx,double ty) {
  _x += tx;
  _y += ty;
};

void Point::rotate(double theta) {
  double xNew = _x*cos(theta) - _y*sin(theta);
  double yNew = _x*sin(theta) + _y*cos(theta);
  _x = xNew;
  _y = yNew;
}

double Point::distance(const Point& p2) {
  return sqrt(pow(_x-p2._x,2)+pow(_y-p2._y,2));
}

std::ostream& operator<<(std::ostream& os, const Point& p) {
  os << "(" << p._x << "," << p._y << ")" << std::endl;
  return os;
}

Point midPoint(const Point& p1, const Point& p2) {
  return Point(0.5*(p1._x+p2._x),0.5*(p1._y+p2._y));
}

