#ifndef _POINT_HPP_
#define _POINT_HPP_
#include <iostream>

// A 2D point
class Point {

  public:

    // Default constructor that initializes coordinates to 0
    Point();
    // Constructor with given coordinates
    Point(const double, const double);
    // Copy constructor
    Point(const Point&);
    
    // Prints coordinates on screen
    void display();
    // Display operator
    friend std::ostream& operator<<(std::ostream&, const Point&);
    // Shifts the point by a vector of coordinates (tx,ty)
    void shift(double tx,double ty);
    // Rotates the point by given angle
    void rotate(double theta);
    // Returns the distance to another Point
    double distance(const Point&);
    // Returns the mid point of two given instances
    friend Point midPoint(const Point&, const Point&);

  private:
    double _x,_y; // The coordinates

};

// Display operator
std::ostream& operator<<(std::ostream&, const Point&);
// Returns the mid point of two given instances
Point midPoint(const Point&, const Point&);

#endif
